'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _list_view_core = require('./list_view_core');

var _list_view_core2 = _interopRequireDefault(_list_view_core);

var _directional_scroller = require('./directional_scroller');

var _directional_scroller2 = _interopRequireDefault(_directional_scroller);

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ListView = function ListView(game, parent, bounds) {
  var _this = this;

  var options = arguments.length <= 3 || arguments[3] === undefined ? {} : arguments[3];


  this.defaultOptions = {
    direction: 'y',
    autocull: true,
    momentum: true,
    bouncing: true,
    snapping: false,
    overflow: 100,
    padding: 10
  };

  bounds = (0, _util.parseBounds)(bounds);

  _list_view_core2.default.call(this, game, parent, bounds, options);

  // we have to use a new mask instance for the click object or webgl ignores the mask
  this.scroller = new _directional_scroller2.default(this.game, this._addMask(bounds), _lodash2.default.extend({
    from: 0,
    to: 0
  }, this.options));
  this.scroller.events.onUpdate.add(function (o) {
    _this.setPosition(o.total);
  });
  this.events.onAdded.add(function (limit) {
    var _to = Math.min(-limit, 0);
    _this.scroller.setFromTo(0, _to);
  });
};

ListView.prototype = Object.assign(Object.create(_list_view_core2.default.prototype), {
  reset: function reset() {
    this.setPosition(0);
    this.scroller.reset();
  }
});
ListView.prototype.constructor = ListView;

exports.default = ListView;